'control constants

CONST   EDIT_1          = 111

'menu constants

CONST   IDM_NEW         = 100
CONST   IDM_OPEN        = 110
CONST   IDM_SAVE        = 120
CONST   IDM_SAVEAS      = 130
CONST   IDM_PRINT       = 140
CONST   IDM_PAGESETUP   = 150
CONST   IDM_EXIT        = 160

'Edit Menu

CONST   IDM_UNDO        = 200
CONST   IDM_SELECTALL   = 205
CONST   IDM_CUT         = 210
CONST   IDM_COPY        = 220
CONST   IDM_PASTE       = 230

' Help Menu

CONST   IDM_HELPTOPICS  = 300
CONST   IDM_ABOUT       = 310

' Window Controls

CONST   IDACCEL         = 400
CONST   IDM_DELETE      = 410
CONST   IDM_CLOSE       = 420
CONST   IDMAINMENU      = 430
CONST   IDAPPLICON      = 440
CONST   IDAPPLCURSOR    = 450
CONST   IDS_FILEMENU    = 2000
CONST   IDS_HELPMENU    = 2010
CONST   IDS_SYSMENU     = 2030
CONST   IDM_STATUSBAR   = 3000
CONST   IDD_ABOUT  = 460
CONST   ID_TOOLBAR  = 805
CONST   IDC_EDIT        = 900

' Tools Controls
CONST   IDM_TLD  = 500
CONST   IDD_TLD  = 501
CONST   IDM_TCD  = 550
CONST   IDD_TCD  = 551
CONST   IDM_TSD  = 600
CONST   IDD_TSD  = 601
CONST   IDM_RLD  = 650
CONST   IDD_RLD  = 651
CONST   IDM_RCD  = 700
CONST   IDD_RCD  = 701
CONST   IDM_RSD  = 750
CONST   IDD_RSD  = 751
CONST   PI = 3.14159265358979
GLOBAL  Brl As Double

'program variables

GLOBAL  AppName$
GLOBAL  Caption$
GLOBAL  AppMenu$

GLOBAL  szFile$
GLOBAL  szFileTitle$

GLOBAL  Form1          AS  HWND
GLOBAL  Edit1          AS  HWND
GLOBAL  Wc             AS  WNDCLASS
GLOBAL  OpenFileName   AS  OPENFILENAME

DIM wRect       AS RECT   'rect structure for window pos
DIM ww          AS DWORD   'window width
DIM wh          AS DWORD   'window height
DIM bNeedSave   AS BOOL
DIM bSave       AS BOOL
DIM iReturn     AS DWORD


FUNCTION WINMAIN
  Brl=0.76
  LOCAL Msg AS  MSG
  AppName$  = "Mark_Editor"
  AppMenu$  = "IDMAINMENU"
  Caption$  = "Mark Editor by AKON (rus)"
  bSave = TRUE
  bNeedSave = FALSE

  If FINDFIRSTINSTANCE(AppName$) Then Exit Function

  Wc.style           = CS_HREDRAW OR CS_VREDRAW
  Wc.lpfnWndProc     = WndProc
  Wc.cbClsExtra      = 0
  Wc.cbWndExtra      = 0
  Wc.hInstance       = hInst
'  Wc.hIcon           = LoadIcon      ( NULL,IDI_APPLICATION )
  Wc.hIcon           = LoadIcon     ( hInst, MAKEINTRESOURCE(12345))
  Wc.hCursor         = LoadCursor       ( NULL,IDC_ARROW )
  Wc.hbrBackground   = GetStockObject     ( WHITE_BRUSH )
  Wc.lpszMenuName    = AppMenu$
  Wc.lpszClassName   = AppName$
  RegisterClass(&Wc)


' create the main window
  Form1 = CreateWindow(AppName$, Caption$, WS_CAPTION OR WS_MAXIMIZEBOX OR WS_MINIMIZEBOX OR _
  WS_SYSMENU OR WS_VISIBLE,0,0, 600, 500, NULL, NULL, hInst, NULL)

' create the edit window
  Edit1 = CreateWindow("edit",NULL, WS_CHILD OR WS_VISIBLE OR WS_BORDER OR _
  ES_LEFT OR WS_HSCROLL OR WS_VSCROLL OR ES_MULTILINE OR  _
  ES_AUTOVSCROLL OR ES_AUTOHSCROLL,0, 0, 550, 450, _
  Form1, EDIT_1, hInst,NULL )

  PosMainWindow  (Form1)              'set main window pos
  ShowWindow    (Form1,CmdShow)       'show that baby!
  UpdateWindow  (Form1)               'update it

  While GetMessage (&Msg,NULL,0,0)    'message loop
    TranslateMessage  (&Msg)
    DispatchMessage   (&Msg)
  Wend

  Function = Msg.wParam               'return this
End Function



FUNCTION InitOpenFileName()                'init the openfilename struct

  szFile$ = ""                               'file to open/save
  szFileTitle$ = ""                          'file name
  OpenFileName.lStructSize       = sizeof(OPENFILENAME)
  OpenFileName.hwndOwner         = Form1
  OpenFileName.hInstance         = GetModuleHandle(0)
' --------------------------------------------------------------------
  ! OpenFileName.lpstrFilter =
  ! "Text Files (*.TXT)\0*.txt\0All Files(*.*)\0*.*\0\0";
' --------------------------------------------------------------------
  OpenFileName.lpstrCustomFilter = NULL
  OpenFileName.nMaxCustFilter    = 0
  OpenFileName.nFilterIndex      = 0
  OpenFileName.lpstrFile         = szFile$
  OpenFileName.nMaxFile          = MAX_PATH
  OpenFileName.lpstrFileTitle    = szFileTitle$
  OpenFileName.nMaxFileTitle     = MAX_PATH
  OpenFileName.lpstrInitialDir   = Curdir$
  OpenFileName.lpstrTitle        = NULL
  OpenFileName.nFileOffset       = 0
  OpenFileName.nFileExtension    = 0
  OpenFileName.lpstrDefExt       = "*.txt"
  OpenFileName.lCustData         = 0
  OpenFileName.lpfnHook          = NULL
  OpenFileName.lpTemplateName    = NULL
  Function = 0

End Function



FUNCTION PopFileOpenDlg (Form1 AS HWND, szFile$, szFileTitle$)
  OpenFileName.lpstrTitle = "Open File"    'text for caption of file dialog box
  OpenFileName.hwndOwner = Form1           'handle of main window
  OpenFileName.lpstrFile = szFile$         'file to open
  OpenFileName.lpstrFileTitle = szFileTitle$         'file name
  OpenFileName.Flags   = OFN_HIDEREADONLY | OFN_CREATEPROMPT 'flags for dialog
  Function = GetOpenFileName (&OpenFileName)
End Function



SUB OpenNewFile(hWnd AS HWND)                         'open file code
  Local t AS DWORD
  Dim FileBuf$
  Dim File$ * 65535                                    'dim buffer for file
  File$ =""                                            'init buffer
  t = EXIST ( szFile$ )                                'make sure file exists
  IF t <> 0  THEN                                    'if it exists
    Open szFile$ For Input As Fp1                      'open 'er up!
    While Not Eof(Fp1)
      Line Input Fp1, FileBuf$
      File$ = File$ & FileBuf$ & chr$(13) & chr$(10)  'add line endings
    Wend
    Close Fp1                                         'close the file
    SendMessage(Edit1,WM_SETTEXT,0,File$)             'put it in the text editor
    Free File$                                        'free memory
  ELSE
    MessageBox( Edit1, "File open failed.", NULL, MB_OK )
  END IF
End Sub



FUNCTION PopFileSaveDlg (Form1 AS HWND, szFile$, szFileTitle$)
  OpenFileName.lpstrTitle        = "Save File"
  OpenFileName.hwndOwner         = Form1
  OpenFileName.lpstrFile         = szFile$
  OpenFileName.lpstrFileTitle    = szFileTitle$
  OpenFileName.Flags             = OFN_OVERWRITEPROMPT
  Function = GetSaveFileName (&OpenFileName)
End Function



SUB SaveOpenFile(hWnd AS HWND)
  Local t AS DWORD
  Local iLength AS DWORD
  iLength = GetWindowTextLength (Edit1)
  Dim File$ * iLength + 1
  File$ = ""
  t = GetWindowText (Edit1, File$, iLength+1)
  IF Not(szFile$="") THEN
    Open szFile$ For Binary New As Fp1
    PUT$ Fp1,File$, LEN(File$)
    Close Fp1
    Free File$
  ELSE
    MessageBox( Edit1, "File Save failed.", NULL, MB_OK )
  END IF
End Sub



Function AboutDlg (hDlg AS HWND, Msg, wParam, lParam)

  Select Case Msg
    Case WM_INITDIALOG
    Center (hDlg)

    Case WM_COMMAND
    If wParam = IDOK Then EndDialog (hDlg, 0)

    Case WM_CLOSE
    EndDialog ( hDlg,0 )

  End Select
  Function = 0
End Function



Function MathRound(tVar As Double,tPow As Integer) As Double
Dim tDiv As Double
Dim tRes As Double

       tDiv=10^tPow
       If tVar=0 Then
             tRes=0
       Else
             tRes=tVar/Abs(tVar)*Int(Abs(tVar)*tDiv+0.5)/tDiv
       End If
      Function=tRes
End Function
Function MathSign(tVar As Double) As Double
Dim tRes As Double

       If tVar<0 Then
             tRes = -1
       Else
             tRes = 1
       End If
      Function = tRes
End Function
Function MathCstr(tVar As Double,tPow As Integer) As String
Dim tDiv As Double
Dim tSign As Double
Dim tFix As Double
Dim tFrac As Double
Dim tRes As Double
Dim tStrFix$
Dim tStrFrac$
Dim tStr$

     If tPow > 0 Then
       tDiv = 10^tPow
       tRes = tVar
       If tVar<0 Then tRes = -tRes
       tRes = tRes+0.5/tDiv
       tFix = Int(tRes)
       tFrac = Int((tRes-tFix)*tDiv)
       tStrFix$ = Trim$(Str$(tFix))
       tStrFrac$ = Trim$(Str$(tFrac))
       If tVar<0 Then tStrFix$ = "-" & tStrFix$
       Do While (Len(tStrFrac$)<tPow)
         tStrFrac$ = "0" & tStrFrac$
       Loop
       tStr$ = tStrFix$ & "." & tStrFrac$
     Else
       tStr$ = STR$(tVar)
     End If
     Function=tStr$
End Function
Function MathPI(tVar As Double) As Double
Dim varPI As Double

      varPI=3.14159265358979*tVar
      Function=varPI
End Function
Function MathEps(tVar As Double) As Double
Dim varEps As Double

      varEps=10^(-7)*tVar
      Function=varEps
End Function
Function MathAtan(tY As Double,tX As Double) As Double
Dim A as Double

      A=0
      If tX=0 Then
            If tY<0 Then
                   A=MathPI(1.5)
            Else
                   A=MathPI(0.5)
            End If
      Else
            A=ATN(tY/tX)
            If tX<0 Then
                   A=A+MathPI(1.0)
            Else
                   If tY<0 Then
                          A=A+MathPI(2.0)
                   End If
            End If
      End If
      Function=A
End Function
Function MathRadToGMS(tRad As Double) As String
Dim tGr As Integer
Dim tMn As Double
Dim tSk As Double
Dim tRes$

      tRad=tRad*180/MathPI(1.0)+0.005/3600
      tGr=Int(tRad)
      tMn=Int((tRad-tGr)*60)
      tSk=Int((tRad-tGr-tMn/60)*3600*100)/100
      tRes$=STR$(tGr) & "'" & STR$(tMn) & "'" & STR$(tSk) & "'"
      Function=tRes$
End Function


SUB SetText (hWnd AS HWND,Txt$)
  BCX_SET_TEXT (hWnd,Txt$)
END SUB

FUNCTION GetText$ (hWnd AS HWND)
  FUNCTION = BCX_GET_TEXT$(hWnd)
END FUNCTION

SUB AppendText (hWnd AS HWND,Txt$)
  BCX_SET_TEXT(hWnd,(BCX_GET_TEXT$(hWnd) & Txt$))
END SUB


Function DlgTLD (hDlg AS HWND, Msg, wParam, lParam)
GLOBAL  hwSelect As HWND
GLOBAL  strTxt$
GLOBAL  strBuffer$
GLOBAL  PK0 As Double
GLOBAL  PKn As Double
GLOBAL  PKpz As Double
GLOBAL  PKpz1 As Double
GLOBAL  PKpz2 As Double
GLOBAL  dPK As Double
GLOBAL  sPK As Double
GLOBAL  deltapz As Double
GLOBAL  deltapz1 As Double
GLOBAL  deltapz2 As Double
GLOBAL  Y0 As Double
GLOBAL  Yn As Double
GLOBAL  dY As Double
GLOBAL  Ypz As Double
GLOBAL  X0 As Double
GLOBAL  Xn As Double
GLOBAL  dX As Double
GLOBAL  Xpz As Double
GLOBAL  Lpk As Double
GLOBAL  sinA As Double
GLOBAL  cosA As Double
GLOBAL  Arad As Double
GLOBAL  Agms$
LOCAL Buffer$

  Select Case Msg
    Case WM_INITDIALOG
      hwSelect = GetDlgItem(hDlg,513)
      strTxt$=STR$(PK0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,515)
      strTxt$=STR$(Y0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,517)
      strTxt$=STR$(X0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,519)
      strTxt$=STR$(PKn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,521)
      strTxt$=STR$(Yn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,523)
      strTxt$=STR$(Xn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,527)
      strTxt$=STR$(Ypz)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,529)
      strTxt$=STR$(Xpz)
      SetText (hwSelect,strTxt$)
      Center (hDlg)

    Case WM_COMMAND
    If wParam = 530 Then
      strBuffer$ = ""
      strBuffer$ = strBuffer$ & (CRLF$ & "Calculation on linear trace" & CRLF$)
      hwSelect = GetDlgItem(hDlg,513)
      strTxt$=GetText$(hwSelect)
      PK0=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PK0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,515)
      strTxt$=GetText$(hwSelect)
      Y0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Y0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,517)
      strTxt$=GetText$(hwSelect)
      X0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   X0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,519)
      strTxt$=GetText$(hwSelect)
      PKn=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,521)
      strTxt$=GetText$(hwSelect)
      Yn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Yn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,523)
      strTxt$=GetText$(hwSelect)
      Xn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Xn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,527)
      strTxt$ = GetText$(hwSelect)
      Ypz=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "Ypz=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,529)
      strTxt$=GetText$(hwSelect)
      Xpz=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Xpz=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer = ""
      
      dY=Yn-Y0
      dX=Xn-X0
      Lpk=sqr(dY^2+dX^2)
      sinA=dY/Lpk
      cosA=dX/Lpk
      Arad=MathAtan(dY,dX)
      Agms$=MathRadToGMS(Arad)
      sPK=PKn-PK0
      If sPK<0 Then sPK=-1 Else sPK=1
      dY=Ypz-Y0
      dX=Xpz-X0
      dPK=dY*sinA+dX*cosA
      PKpz1=PK0+sPK*dPK
      deltapz1=dY*cosA-dX*sinA
      deltapz1=sPK*deltapz1
      dY=Ypz-Yn
      dX=Xpz-Xn
      dPK=dY*sinA+dX*cosA
      PKpz2=PKn+sPK*dPK
      deltapz2=dY*cosA-dX*sinA
      deltapz2=sPK*deltapz1
      PKpz=(PKpz1+PKpz2)/2
      deltapz=(deltapz1+deltapz2)/2

      strTxt$=MathCstr$(PKpz,4)
      hwSelect = GetDlgItem(hDlg,534)
      SetText (hwSelect,strTxt$)

      strTxt$=MathCstr$(deltapz,4)
      hwSelect = GetDlgItem(hDlg,536)
      SetText (hwSelect,strTxt$)

      strBuffer$ = ""
      strBuffer$ = strBuffer$ & (CRLF$ & "Apk=" & Agms$)
      strTxt$=MathCstr$(Lpk,4)
      strBuffer$ = strBuffer$ & ("   Lpk=" & strTxt$ & CRLF$)
      strTxt$=MathCstr$(PKpz1,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKpz1=" & strTxt$)
      strTxt$=MathCstr$(deltapz1,4)
      strBuffer$ = strBuffer$ & ("   Dpz1=" & strTxt$)
      strTxt$=MathCstr$(PKpz2,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKpz2=" & strTxt$)
      strTxt$=MathCstr$(deltapz2,4)
      strBuffer$ = strBuffer$ & ("   Dpz2=" & strTxt$ & CRLF$)

      AppendText (Edit1,strBuffer$)
      strBuffer$ = ""
    End If
    If wParam = 537 Then EndDialog (hDlg, 0)

    Case WM_CLOSE
    EndDialog ( hDlg,0 )

  End Select
  Function = 0
End Function


Function DlgTCD (hDlg AS HWND, Msg, wParam, lParam)
GLOBAL  hwSelect As HWND
GLOBAL  strTxt$
GLOBAL  strBuffer$
GLOBAL  PK0 As Double
GLOBAL  PKn As Double
GLOBAL  PKpz As Double
GLOBAL  PKpz1 As Double
GLOBAL  PKpz2 As Double
GLOBAL  dPK As Double
GLOBAL  sPK As Double
GLOBAL  deltapz As Double
GLOBAL  deltapz1 As Double
GLOBAL  deltapz2 As Double
GLOBAL  Y0 As Double
GLOBAL  Yn As Double
GLOBAL  Yck As Double
GLOBAL  dY As Double
GLOBAL  Ypz As Double
GLOBAL  X0 As Double
GLOBAL  Xn As Double
GLOBAL  Xck As Double
GLOBAL  dX As Double
GLOBAL  Xpz As Double
GLOBAL  Rkk As Double
GLOBAL  R0 As Double
GLOBAL  Rn As Double
GLOBAL  Rpz As Double
GLOBAL  Zkk As Double
GLOBAL  Qkk As Double
GLOBAL  A0 As Double
GLOBAL  An As Double
GLOBAL  Apz As Double
GLOBAL  dA0 As Double
GLOBAL  dAn As Double
GLOBAL  Beta As Double
GLOBAL  Lpk As Double
GLOBAL  sBeta As Double
GLOBAL  Agms$

  Select Case Msg
    Case WM_INITDIALOG
      hwSelect = GetDlgItem(hDlg,563)
      strTxt$=STR$(PK0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,565)
      strTxt$=STR$(Y0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,567)
      strTxt$=STR$(X0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,569)
      strTxt$=STR$(PKn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,571)
      strTxt$=STR$(Yn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,573)
      strTxt$=STR$(Xn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,576)
      strTxt$=STR$(Yck)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,578)
      strTxt$=STR$(Xck)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,580)
      strTxt$=STR$(Rkk)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,582)
      strTxt$=STR$(Zkk)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,584)
      strTxt$=STR$(Qkk)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,588)
      strTxt$=STR$(Ypz)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,590)
      strTxt$=STR$(Xpz)
      SetText (hwSelect,strTxt$)
      Center (hDlg)

    Case WM_COMMAND
    If wParam = 591 Then
      strBuffer$ = ""
      strBuffer$ = strBuffer$ & (CRLF$ & "Calculation on circular crooked trace" & CRLF$)
      hwSelect = GetDlgItem(hDlg,563)
      strTxt$=GetText$(hwSelect)
      PK0=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PK0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,565)
      strTxt$=GetText$(hwSelect)
      Y0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Y0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,567)
      strTxt$=GetText$(hwSelect)
      X0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   X0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,569)
      strTxt$=GetText$(hwSelect)
      PKn=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,571)
      strTxt$=GetText$(hwSelect)
      Yn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Yn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,573)
      strTxt$=GetText$(hwSelect)
      Xn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Xn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,576)
      strTxt$=GetText$(hwSelect)
      Yck=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "CENTR: Yck=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,578)
      strTxt$=GetText$(hwSelect)
      Xck=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Xck=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,580)
      strTxt$=GetText$(hwSelect)
      Rkk=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "R=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,582)
      strTxt$=GetText$(hwSelect)
      Zkk=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   z=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,584)
      strTxt$=GetText$(hwSelect)
      Qkk=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   q=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,588)
      strTxt$ = GetText$(hwSelect)
      Ypz=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "Ypz=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,590)
      strTxt$=GetText$(hwSelect)
      Xpz=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Xpz=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer = ""
      
      sPK=PKn-PK0
      If sPK<0 Then sPK=-1 Else sPK=1
      dY=Y0-Yck
      dX=X0-Xck
      R0=sqr(dY^2+dX^2)
      A0=MathAtan(dY,dX)
      dY=Yn-Yck
      dX=Xn-Xck
      Rn=sqr(dY^2+dX^2)
      An=MathAtan(dY,dX)
      Beta=An-A0
      If Beta<0 Then Beta=MathPI(2.0)+Beta
      If Beta>MathPI(1.0) Then Beta=Beta-MathPI(2.0)
      sBeta=1
      If Beta<0 Then sBeta=-1
      Lpk=sBeta*Rkk*Beta

      strBuffer$ = ""
      strTxt$=MathCstr$(R0,4)
      Agms$=MathRadToGMS(A0)
      strBuffer$ = strBuffer$ & (CRLF$ & "Ankk=" & Agms$ & "   Rnkk=" & strTxt$)
      strTxt$=MathCstr$(Rn,4)
      Agms$=MathRadToGMS(An)
      strBuffer$ = strBuffer$ & (CRLF$ & "Akkk=" & Agms$ & "   Rkkk=" & strTxt$)
      Agms$=MathRadToGMS(Beta)
      strTxt$=MathCstr$(Lpk,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "Beta=" & Agms$ & "   Lkk=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer$ = ""

      dY=Ypz-Yck
      dX=Xpz-Xck
      Apz=MathAtan(dY,dX)
      Rpz=Sqr(dY^2+dX^2)
      dA0=Apz-A0
      If dA0<0 Then dA0=MathPI(2.0)+dA0
      If dA0>MathPI(1.0) Then dA0=dA0-MathPI(2.0)
      dAn=Apz-An
      If dAn<0 Then dAn=MathPI(2.0)+dAn
      If dAn>MathPI(1.0) Then dAn=dAn-MathPI(2.0)

      strBuffer$ = ""
      Agms$=MathRadToGMS(Apz)
      strTxt$=MathCstr$(Rpz,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "Apz=" & Agms$ & "   Rpz=" & strTxt$)

      If ((Abs(dA0)>Abs(Beta)) OR (Abs(dAn)>Abs(Beta))) Then
        PKpz=0
        deltapz=0
        strBuffer$ = strBuffer$ & (CRLF$ & "!Point outside of circular crooked!" & CRLF$)
      Else
        PKpz1=PK0+sBeta*Rkk*dA0
        PKpz2=PKn+sBeta*Rkk*dAn
        PKpz=(PKpz1+PKpz2)/2
        deltapz=Rpz-(Rkk-Zkk-Qkk)
        strTxt$=MathCstr$(PKpz1,4)
        strBuffer$ = strBuffer$ & (CRLF$ & "PKpz1=" & strTxt$)
        strTxt$=MathCstr$(deltapz,4)
        strBuffer$ = strBuffer$ & ("   Dpz=" & strTxt$)
        strTxt$=MathCstr$(PKpz2,4)
        strBuffer$ = strBuffer$ & (CRLF$ & "PKpz2=" & strTxt$)
        strTxt$=MathCstr$(deltapz,4)
        strBuffer$ = strBuffer$ & ("   Dpz=" & strTxt$ & CRLF$)
      End If

      strTxt$=MathCstr$(PKpz,4)
      hwSelect = GetDlgItem(hDlg,595)
      SetText (hwSelect,strTxt$)

      strTxt$=MathCstr$(deltapz,4)
      hwSelect = GetDlgItem(hDlg,597)
      SetText (hwSelect,strTxt$)

      AppendText (Edit1,strBuffer$)
      strBuffer$ = ""
    End If
    If wParam = 537 Then EndDialog (hDlg, 0)

    Case WM_CLOSE
    EndDialog ( hDlg,0 )

  End Select
  Function = 0
End Function


Function DlgTSD (hDlg AS HWND, Msg, wParam, lParam)
GLOBAL  hwSelect As HWND
GLOBAL  strTxt$
GLOBAL  strBuffer$
GLOBAL  PK0 As Double
GLOBAL  PKn As Double
GLOBAL  PKnsk As Double
GLOBAL  PKksk As Double
GLOBAL  PKpz As Double
GLOBAL  dPK As Double
GLOBAL  sPK As Double
GLOBAL  delta As Double
GLOBAL  deltapz As Double
GLOBAL  Y0 As Double
GLOBAL  Yn As Double
GLOBAL  Yck As Double
GLOBAL  dY As Double
GLOBAL  Ypz As Double
GLOBAL  X0 As Double
GLOBAL  Xn As Double
GLOBAL  Xck As Double
GLOBAL  dX As Double
GLOBAL  Xpz As Double
GLOBAL  y0pz As Double
GLOBAL  x0pz As Double
GLOBAL  yipz As Double
GLOBAL  xipz As Double
GLOBAL  lipz As Double
GLOBAL  fipz As Double
GLOBAL  Dipz As Double
GLOBAL  dxipz As Double
GLOBAL  Rkk As Double
GLOBAL  Rk As Double
GLOBAL  Csk As Double
GLOBAL  Lsk As Double
GLOBAL  Xsk As Double
GLOBAL  Ysk As Double
GLOBAL  FIsk As Double
GLOBAL  Zsk As Double
GLOBAL  Zsk As Double
GLOBAL  Qsk As Double
GLOBAL  Ask As Double
GLOBAL  A1sk As Double
GLOBAL  Qpz As Double
GLOBAL  A0 As Double
GLOBAL  An As Double
GLOBAL  Apz As Double
GLOBAL  dA0 As Double
GLOBAL  dAn As Double
GLOBAL  Lpk As Double
GLOBAL  sBeta As Double
GLOBAL  Agms$

  Select Case Msg
    Case WM_INITDIALOG
      hwSelect = GetDlgItem(hDlg,613)
      strTxt$=STR$(PK0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,615)
      strTxt$=STR$(Y0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,617)
      strTxt$=STR$(X0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,619)
      strTxt$=STR$(PKn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,621)
      strTxt$=STR$(Yn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,623)
      strTxt$=STR$(Xn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,626)
      strTxt$=STR$(Yck)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,628)
      strTxt$=STR$(Xck)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,630)
      strTxt$=STR$(Rkk)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,632)
      strTxt$=STR$(Lsk)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,634)
      strTxt$=STR$(Qsk)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,638)
      strTxt$=STR$(Ypz)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,640)
      strTxt$=STR$(Xpz)
      SetText (hwSelect,strTxt$)
      Center (hDlg)

    Case WM_COMMAND
    If wParam = 641 Then
      strBuffer$ = ""
      strBuffer$ = strBuffer$ & (CRLF$ & "Calculation on circular crooked trace" & CRLF$)
      hwSelect = GetDlgItem(hDlg,613)
      strTxt$=GetText$(hwSelect)
      PK0=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PK_l=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,615)
      strTxt$=GetText$(hwSelect)
      Y0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Y_l=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,617)
      strTxt$=GetText$(hwSelect)
      X0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   X_l=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,619)
      strTxt$=GetText$(hwSelect)
      PKn=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PK_nkk=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,621)
      strTxt$=GetText$(hwSelect)
      Yn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Y_nkk=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,623)
      strTxt$=GetText$(hwSelect)
      Xn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   X_nkk=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,626)
      strTxt$=GetText$(hwSelect)
      Yck=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "CENTR: Yck=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,628)
      strTxt$=GetText$(hwSelect)
      Xck=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Xck=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,630)
      strTxt$=GetText$(hwSelect)
      Rkk=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "R_kk=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,632)
      strTxt$=GetText$(hwSelect)
      Lsk=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   L_sk=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,634)
      strTxt$=GetText$(hwSelect)
      Qsk=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   q=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,638)
      strTxt$ = GetText$(hwSelect)
      Ypz=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "Ypz=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,640)
      strTxt$=GetText$(hwSelect)
      Xpz=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   Xpz=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer = ""
      
      dY=Yn-Y0
      dX=Xn-X0
      Lpk=sqr(dY^2+dX^2)
      sinA=dY/Lpk
      cosA=dX/Lpk
      Arad=MathAtan(dY,dX)
      Agms$=MathRadToGMS(Arad)
      sPK=PKn-PK0
      If sPK<0 Then sPK=-1 Else sPK=1
      dY=Yck-Yn
      dX=Xck-Xn
      delta=dY*cosA-dX*sinA
      Rk=Sqr(dY^2+dX^2)

      strBuffer$ = ""
      strBuffer$ = strBuffer$ & (CRLF$ & "Apk=" & Agms$)
      strTxt$=MathCstr$(Lpk,4)
      strBuffer$ = strBuffer$ & ("   Lpk=" & strTxt$)
      strTxt$=MathCstr$(Rk,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "Rk=" & strTxt$)
      If delta<0 Then
        sBeta=-1
        strBuffer$ = strBuffer$ & ("   !Left!")
      Else
        sBeta=1
        strBuffer$ = strBuffer$ & ("   !Right!")
      End If
      Csk=Rkk*Lsk
      Ask=Lsk/2+(Lsk^5)/(60*Csk^2)
      A1sk=Lsk/2-(Lsk^5)/(24*Csk^2)
      Xsk=Lsk-(Lsk^5)/(40*Csk^2)
      Ysk=(Lsk^3)/(6*Csk)-(Lsk^7)/(336*Csk^3)
      Zsk=(Lsk^3)/(24*Csk)+(13*Lsk^7)/(2688*Csk^3)
      FIsk=(Lsk^2)/(2*Csk)
      PKnsk=PKn-sPK*Ask
      PKksk=PKnsk+sPK*Lsk
      strTxt$=MathCstr$(Csk,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "C=" & strTxt$)
      strTxt$=MathCstr$(Ask,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "a=" & strTxt$)
      strTxt$=MathCstr$(A1sk,4)
      strBuffer$ = strBuffer$ & ("   a1=" & strTxt$)
      strTxt$=MathCstr$(Xsk,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "(X)=" & strTxt$)
      strTxt$=MathCstr$(Ysk,4)
      strBuffer$ = strBuffer$ & ("   (Y)=" & strTxt$)
      strTxt$=MathCstr$(Zsk,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "(Z)=" & strTxt$)
      strTxt$=MathRadToGMS(FIsk)
      strBuffer$ = strBuffer$ & ("   (FI)=" & strTxt$)
      strTxt$=MathCstr$(PKnsk,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKnsk=" & strTxt$)
      strTxt$=MathCstr$(PKksk,4)
      strBuffer$ = strBuffer$ & ("   PKksk=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer = ""

      dY=Ypz-Yn
      dX=Xpz-Xn
      x0pz=dY*sinA+dX*cosA
      x0pz=x0pz+Ask
      y0pz=dY*cosA-dX*sinA
      y0pz=sBeta*y0pz
      strBuffer$ = ""
      strTxt$=MathCstr$(x0pz,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "(x)pz=" & strTxt$)
      strTxt$=MathCstr$(y0pz,4)
      strBuffer$ = strBuffer$ & ("   (y)pz=" & strTxt$)

      If ((x0pz<0) OR (x0pz>Lsk)) Then
        PKpz=0
        deltapz=0
        strBuffer$ = strBuffer$ & (CRLF$ & "!Point outside of connecting crooked!" & CRLF$)
      Else
        yipz=y0pz
        xipz=x0pz
        lipz=x0pz
        Do
          fipz=(lipz^2)/(2*Csk)
          Dipz=(y0pz-(lipz^3)/(6*Csk)+(lipz^7)/(336*Csk^3))/cos(fipz)
          xipz=lipz-(lipz^5)/(40*Csk^2)-Dipz*sin(fipz)
          dxipz=ABS(x0pz-xipz)
          lipz=lipz+(x0pz-xipz)
        Loop Until (dxipz<MathEps(1))
        Qpz=Qsk*lipz/Lsk
        y0pz=sBeta*y0pz
        xipz=lipz-(lipz^5)/(40*Csk^2)
        yipz=(lipz^3)/(6*Csk)-(lipz^7)/(336*Csk^3)
        PKpz=PKnsk+sPK*lipz
        deltapz=sBeta*sPK*(Dipz-Qpz)
        strTxt$=MathCstr$(xipz,4)
        strBuffer$ = strBuffer$ & (CRLF$ & "(x0)pz=" & strTxt$)
        strTxt$=MathCstr$(yipz,4)
        strBuffer$ = strBuffer$ & ("   (y0)pz=" & strTxt$)
        strTxt$=MathCstr$(lipz,4)
        strBuffer$ = strBuffer$ & (CRLF$ & "Lpz=" & strTxt$)
        strTxt$=MathCstr$(Qpz,4)
        strBuffer$ = strBuffer$ & ("   qpz=" & strTxt$  & CRLF$)
        strTxt$=MathCstr$(PKpz,4)
        strBuffer$ = strBuffer$ & (CRLF$ & "PKpz=" & strTxt$)
        strTxt$=MathCstr$(deltapz,4)
        strBuffer$ = strBuffer$ & ("   Dpz=" & strTxt$  & CRLF$)
      End If

      strTxt$=MathCstr$(PKpz,4)
      hwSelect = GetDlgItem(hDlg,645)
      SetText (hwSelect,strTxt$)

      strTxt$=MathCstr$(deltapz,4)
      hwSelect = GetDlgItem(hDlg,647)
      SetText (hwSelect,strTxt$)

      AppendText (Edit1,strBuffer$)
      strBuffer$ = ""
    End If
    If wParam = 537 Then EndDialog (hDlg, 0)

    Case WM_CLOSE
    EndDialog ( hDlg,0 )

  End Select
  Function = 0
End Function



Function DlgRLD (hDlg AS HWND, Msg, wParam, lParam)
GLOBAL  hwSelect As HWND
GLOBAL  strTxt$
GLOBAL  strBuffer$
GLOBAL  PK0 As Double
GLOBAL  PKn As Double
GLOBAL  PKrp As Double
GLOBAL  d0 As Double
GLOBAL  dn As Double
GLOBAL  m0 As Double
GLOBAL  mn As Double
GLOBAL  mrp As Double
GLOBAL  l0 As Double
GLOBAL  ln As Double
GLOBAL  Gl As Double
GLOBAL  Yrp As Double

  Select Case Msg
    Case WM_INITDIALOG
      hwSelect = GetDlgItem(hDlg,654)
      strTxt$=STR$(PK0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,656)
      strTxt$=STR$(d0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,658)
      strTxt$=STR$(m0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,660)
      strTxt$=STR$(PKn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,662)
      strTxt$=STR$(dn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,664)
      strTxt$=STR$(mn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,668)
      strTxt$=STR$(PKrp)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,670)
      strTxt$=STR$(mrp)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,675)
      strTxt$=STR$(Brl)
      SetText (hwSelect,strTxt$)
      Center (hDlg)

    Case WM_COMMAND
    If wParam = 671 Then
      strBuffer$ = ""
      strBuffer$ = strBuffer$ & (CRLF$ & "Calculation Rail size of Linear trace" & CRLF$)
      hwSelect = GetDlgItem(hDlg,654)
      strTxt$=GetText$(hwSelect)
      PK0=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PK0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,656)
      strTxt$=GetText$(hwSelect)
      d0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   d0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,658)
      strTxt$=GetText$(hwSelect)
      m0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   m0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,660)
      strTxt$=GetText$(hwSelect)
      PKn=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,662)
      strTxt$=GetText$(hwSelect)
      dn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   dn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,664)
      strTxt$=GetText$(hwSelect)
      mn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   mn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,668)
      strTxt$ = GetText$(hwSelect)
      PKrp=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKrp=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,670)
      strTxt$=GetText$(hwSelect)
      mrp=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   mrp=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,675)
      strTxt$=GetText$(hwSelect)
      Brl=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "Brl=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer = ""
      
      l0=d0-m0
      ln=dn-mn
      Gl=(ln-l0)/(PKn-PK0)*(PKrp-PK0)
      Yrp=Gl+l0+mrp-Brl

      strTxt$=MathCstr$(Yrp,4)
      hwSelect = GetDlgItem(hDlg,677)
      SetText (hwSelect,strTxt$)

      strBuffer$ = ""
      strTxt$=MathCstr$(Yrp,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "Yrp=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer$ = ""
    End If
    If wParam = 678 Then EndDialog (hDlg, 0)

    Case WM_CLOSE
    EndDialog ( hDlg,0 )

  End Select
  Function = 0
End Function


Function DlgRCD (hDlg AS HWND, Msg, wParam, lParam)
GLOBAL  hwSelect As HWND
GLOBAL  strTxt$
GLOBAL  strBuffer$
GLOBAL  PK0 As Double
GLOBAL  PKn As Double
GLOBAL  PKrp As Double
GLOBAL  dPK As Double
GLOBAL  d0 As Double
GLOBAL  dn As Double
GLOBAL  m0 As Double
GLOBAL  mn As Double
GLOBAL  mrp As Double
GLOBAL  l0 As Double
GLOBAL  ln As Double
GLOBAL  Rkk As Double
GLOBAL  Zkk As Double
GLOBAL  Lpk As Double
GLOBAL  Gl As Double
GLOBAL  SPrl As Double
GLOBAL  dSPl As Double
GLOBAL  pdSP As Double
GLOBAL  SPI As Double
GLOBAL  dSP As Double
GLOBAL  Yrp As Double

  Select Case Msg
    Case WM_INITDIALOG
      hwSelect = GetDlgItem(hDlg,704)
      strTxt$=STR$(PK0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,706)
      strTxt$=STR$(d0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,708)
      strTxt$=STR$(m0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,710)
      strTxt$=STR$(PKn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,712)
      strTxt$=STR$(dn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,714)
      strTxt$=STR$(mn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,718)
      strTxt$=STR$(Rkk)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,720)
      strTxt$=STR$(Zkk)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,724)
      strTxt$=STR$(PKrp)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,726)
      strTxt$=STR$(mrp)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,731)
      strTxt$=STR$(Brl)
      SetText (hwSelect,strTxt$)
      Center (hDlg)

    Case WM_COMMAND
    If wParam = 671 Then
      strBuffer$ = ""
      strBuffer$ = strBuffer$ & (CRLF$ & "Calculation Rail size of Linear trace" & CRLF$)
      hwSelect = GetDlgItem(hDlg,704)
      strTxt$=GetText$(hwSelect)
      PK0=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PK0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,706)
      strTxt$=GetText$(hwSelect)
      d0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   d0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,708)
      strTxt$=GetText$(hwSelect)
      m0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   m0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,710)
      strTxt$=GetText$(hwSelect)
      PKn=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,712)
      strTxt$=GetText$(hwSelect)
      dn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   dn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,714)
      strTxt$=GetText$(hwSelect)
      mn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   mn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,718)
      strTxt$ = GetText$(hwSelect)
      Rkk=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "R=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,720)
      strTxt$=GetText$(hwSelect)
      Zkk=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   z=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,724)
      strTxt$ = GetText$(hwSelect)
      PKrp=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKrp=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,726)
      strTxt$=GetText$(hwSelect)
      mrp=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   mrp=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,731)
      strTxt$=GetText$(hwSelect)
      Brl=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "Brl=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer = ""
      
      l0=d0-m0
      ln=dn-mn
      Lpk=Abs(PKn-PK0)
	  Gl=(ln-l0)/Lpk
	  SPrl=Lpk^2/8/Rkk
	  dPK=Abs(PKrp-PK0)
	  dSPl=Lpk/2-dPK
	  pdSP=Abs(dSPl)
	  SPI=pdSP^2/2/Rkk
	  dSP=(SPrl-SPI)
	  Yrp=Gl*dPK+mrp+l0+Zkk-Brl-dSP

      strTxt$=MathCstr$(Yrp,4)
      hwSelect = GetDlgItem(hDlg,733)
      SetText (hwSelect,strTxt$)

      strBuffer$ = ""
      strTxt$=MathCstr$(Yrp,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "Yrp=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer$ = ""
    End If
    If wParam = 734 Then EndDialog (hDlg, 0)

    Case WM_CLOSE
    EndDialog ( hDlg,0 )

  End Select
  Function = 0
End Function


Function DlgRSD (hDlg AS HWND, Msg, wParam, lParam)
GLOBAL  hwSelect As HWND
GLOBAL  strTxt$
GLOBAL  strBuffer$
GLOBAL  PK0 As Double
GLOBAL  PKn As Double
GLOBAL  PKrp As Double
GLOBAL  dPK As Double
GLOBAL  d0 As Double
GLOBAL  dn As Double
GLOBAL  m0 As Double
GLOBAL  mn As Double
GLOBAL  mrp As Double
GLOBAL  l0 As Double
GLOBAL  ln As Double
GLOBAL  Csk As Double
GLOBAL  Lpk As Double
GLOBAL  ySK As Double
GLOBAL  Ml As Double
GLOBAL  Yrp As Double

  Select Case Msg
    Case WM_INITDIALOG
      hwSelect = GetDlgItem(hDlg,754)
      strTxt$=STR$(PK0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,756)
      strTxt$=STR$(d0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,758)
      strTxt$=STR$(m0)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,760)
      strTxt$=STR$(PKn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,762)
      strTxt$=STR$(dn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,764)
      strTxt$=STR$(mn)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,769)
      strTxt$=STR$(PKnsk)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,771)
      strTxt$=STR$(Csk)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,775)
      strTxt$=STR$(PKrp)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,777)
      strTxt$=STR$(mrp)
      SetText (hwSelect,strTxt$)
      hwSelect = GetDlgItem(hDlg,782)
      strTxt$=STR$(Brl)
      SetText (hwSelect,strTxt$)
      Center (hDlg)

    Case WM_COMMAND
    If wParam = 778 Then
      strBuffer$ = ""
      strBuffer$ = strBuffer$ & (CRLF$ & "Calculation Rail size of Linear trace" & CRLF$)
      hwSelect = GetDlgItem(hDlg,754)
      strTxt$=GetText$(hwSelect)
      PK0=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PK0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,756)
      strTxt$=GetText$(hwSelect)
      d0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   d0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,758)
      strTxt$=GetText$(hwSelect)
      m0=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   m0=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,760)
      strTxt$=GetText$(hwSelect)
      PKn=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,762)
      strTxt$=GetText$(hwSelect)
      dn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   dn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,764)
      strTxt$=GetText$(hwSelect)
      mn=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   mn=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,769)
      strTxt$ = GetText$(hwSelect)
      PKnsk=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKnsk=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,771)
      strTxt$=GetText$(hwSelect)
      Csk=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   C=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,775)
      strTxt$ = GetText$(hwSelect)
      PKrp=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "PKrp=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,777)
      strTxt$=GetText$(hwSelect)
      mrp=Val(strTxt$)
      strBuffer$ = strBuffer$ & ("   mrp=" & strTxt$)
      hwSelect = GetDlgItem(hDlg,782)
      strTxt$=GetText$(hwSelect)
      Brl=Val(strTxt$)
      strBuffer$ = strBuffer$ & (CRLF$ & "Brl=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer = ""
      
      l0=d0-m0
      ln=dn-mn
	  dPK=Abs(PKrp-PKnsk)
      ySK=(dPK^3)/6/Csk-(dPK^7)/336/Csk^3+(dPK^11)/42240/Csk^5
      Ml=l0+mrp+(ln-l0)/Abs(PKn-PK0)*Abs(PKrp-PK0)
      Yrp=ySK+Ml+(ySK+Ml)/8/(Csk^2)*(dPK^4)-Brl

      strTxt$=MathCstr$(Yrp,4)
      hwSelect = GetDlgItem(hDlg,784)
      SetText (hwSelect,strTxt$)

      strBuffer$ = ""
      strTxt$=MathCstr$(Yrp,4)
      strBuffer$ = strBuffer$ & (CRLF$ & "Yrp=" & strTxt$ & CRLF$)
      AppendText (Edit1,strBuffer$)
      strBuffer$ = ""
    End If
    If wParam = 785 Then EndDialog (hDlg, 0)

    Case WM_CLOSE
    EndDialog ( hDlg,0 )

  End Select
  Function = 0
End Function



CALLBACK FUNCTION WndProc
  DIM T$
  DIM hDC AS HDC
  DIM ps  AS PAINTSTRUCT
  Dim i

  SELECT CASE CBMSG

    CASE WM_COMMAND
    IF LOWORD (wParam) = EDIT_1 THEN
      IF HIWORD (wParam) = EN_CHANGE THEN
        bNeedSave = TRUE
        IF HIWORD (wParam) = EN_ERRSPACE OR HIWORD (wParam) = EN_MAXTEXT THEN
          MsgBox  "Edit control out of space.","Error!", 16
          EXIT FUNCTION
        END IF
      END IF
      EXIT FUNCTION
    END IF

    IF LOWORD(wParam) = IDM_NEW THEN
      SendMessage(Edit1,EM_SETSEL,0,MAKELONG(-1,0))
      SendMessage(Edit1,WM_CLEAR,0,0)
      szFile$ = ""
      szFileTitle$ = ""
      Caption$ = "Mark Editor by AKON (rus)"
      SetWindowText (Form1, Caption$)
      bNeedSave = FALSE
      EXIT FUNCTION
    END IF

    IF LOWORD(wParam) = IDM_OPEN THEN
      IF bNeedSave THEN i = (AskAboutSave (Edit1, szFileTitle$))

      IF i = IDCANCEL THEN
        Function = 0
      END IF

      IF i = IDNO THEN
        bNeedSave = FALSE
      END IF

      IF i = IDYES THEN
        InitOpenFileName()
        PopFileSaveDlg (Form1, szFile$, szFileTitle$)
        SaveOpenFile(Edit1)
        bNeedSave = FALSE
      END IF

      IF not bNeedSave THEN
        Caption$ = "Mark Editor by AKON (rus)"
        SetWindowText (Form1, Caption$)
        InitOpenFileName()
        PopFileOpenDlg (Form1, szFile$, szFileTitle$)
        OpenNewFile(Edit1)
        Caption$ = Caption$ & " - " & szFile$
        SetWindowText (Form1, Caption$)
        bNeedSave = FALSE
      END IF
    END IF

    IF LOWORD(wParam) = IDM_PRINT THEN
      MsgBox "Sorry - Not implemented yet!", "Notice", 64
    END IF

    IF LOWORD(wParam) = IDM_SAVE THEN
      Caption$ = "Mark Editor by AKON (rus)"
      SetWindowText (Form1, Caption$)
      SaveOpenFile(Edit1)
      Caption$ = Caption$ & " - " & szFile$
      SetWindowText (Form1, Caption$)
      bNeedSave = FALSE
      EXIT FUNCTION
    END IF

    IF LOWORD(wParam) = IDM_SAVEAS THEN
      IF bNeedSave THEN
        i = (AskAboutSave (Edit1, szFileTitle$))
        IF i = IDCANCEL THEN
          EXIT FUNCTION
        END IF

        IF i = IDNO THEN
          bSave = FALSE
        END IF

        IF i = IDYES THEN
          bSave = TRUE
        END IF

      END IF

      IF bSave THEN
        szFile$ = ""
        szFileTitle$ = ""
        InitOpenFileName()
        PopFileSaveDlg (Form1, szFile$, szFileTitle$)
        SaveOpenFile(Edit1)
        Caption$ = Caption$ & " - " & szFile$
        SetWindowText (Form1, Caption$)
        bNeedSave = FALSE
      END IF
    END IF

    IF LOWORD(wParam) = IDM_PRINT THEN
      notice("Sorry - Not implemented yet!")
    END IF

    IF LOWORD(wParam) = IDM_DELETE THEN
      SendMessage(Edit1, WM_CLEAR, 0, 0)
      Caption$ = Caption$ & " - " & szFile$
      SetWindowText (Form1, Caption$)
      bNeedSave = TRUE
    END IF

    IF LOWORD(wParam) = IDM_UNDO THEN
      IF SendMessage(Edit1, EM_CANUNDO,0,0) THEN
        SendMessage(Edit1, WM_UNDO, 0, 0)
      ELSE
        MsgBox  "Nothing to undo!","Undo Notification", 0
      END IF
    END IF

    IF LOWORD(wParam) = IDM_CUT THEN
      SendMessage (Edit1, WM_CUT, 0, 0)
    END IF

    IF LOWORD(wParam) = IDM_COPY THEN
      SendMessage (Edit1, WM_COPY, 0, 0)
    END IF

    IF LOWORD(wParam) = IDM_PASTE THEN
      SendMessage (Edit1, WM_PASTE, 0, 0)
    END IF

    IF LOWORD(wParam) = IDM_SELECTALL THEN
      SendMessage (Edit1, EM_SETSEL, 0, MAKELONG(-1,0))
    END IF

    IF LOWORD(wParam) = IDM_EXIT  THEN   ' Was the EXIT menu clicked?
      IF bNeedSave = TRUE THEN
        MsgBox "File has changed. Save?", "Confirm", 35
        IF IDYES THEN
          InitOpenFileName()
          PopFileSaveDlg (Form1, szFile$, szFileTitle$)
          SaveOpenFile(Edit1)
        END IF
      END IF
      PostQuitMessage(0)                ' Yes .. Terminate program
    END IF

    IF LOWORD(wParam) = IDM_ABOUT THEN
      MessageBeep(MB_OK)
      DialogBox(GetModuleHandle(0),MAKEINTRESOURCE(IDD_ABOUT),Form1,AboutDlg)
    END IF

    IF LOWORD(wParam) = IDM_TLD THEN
      MessageBeep(MB_OK)
      DialogBox(GetModuleHandle(0),MAKEINTRESOURCE(IDD_TLD),Form1,DlgTLD)
    END IF

    IF LOWORD(wParam) = IDM_TCD THEN
      MessageBeep(MB_OK)
      DialogBox(GetModuleHandle(0),MAKEINTRESOURCE(IDD_TCD),Form1,DlgTCD)
    END IF

    IF LOWORD(wParam) = IDM_TSD THEN
      MessageBeep(MB_OK)
      DialogBox(GetModuleHandle(0),MAKEINTRESOURCE(IDD_TSD),Form1,DlgTSD)
    END IF

    IF LOWORD(wParam) = IDM_RLD THEN
      MessageBeep(MB_OK)
      DialogBox(GetModuleHandle(0),MAKEINTRESOURCE(IDD_RLD),Form1,DlgRLD)
    END IF

    IF LOWORD(wParam) = IDM_RCD THEN
      MessageBeep(MB_OK)
      DialogBox(GetModuleHandle(0),MAKEINTRESOURCE(IDD_RCD),Form1,DlgRCD)
    END IF

    IF LOWORD(wParam) = IDM_RSD THEN
      MessageBeep(MB_OK)
      DialogBox(GetModuleHandle(0),MAKEINTRESOURCE(IDD_RSD),Form1,DlgRSD)
    END IF
    EXIT FUNCTION

    CASE WM_SETFOCUS
    SetFocus(Edit1)
    EXIT FUNCTION

    CASE WM_PAINT
    hDC = BeginPaint(hWnd,&ps)
    T$ = "Editbox is using" & Str$(GetWindowTextLength(Edit1)) & " bytes"
    TextOut(hDC,75,128,T$,len(T$))
    EndPaint(hWnd,&ps)
    EXIT FUNCTION

    CASE WM_SIZE 'set editor size
    MoveWindow(Edit1,0, 0, LOWORD(lParam), HIWORD(lParam), TRUE)
    EXIT FUNCTION

    CASE WM_KEYDOWN
    IF wParam = VK_DELETE THEN
      SendMessage(Edit1, WM_CLEAR, 0, 0)
      Caption$ = Caption$ & " - " & szFile$
      SetWindowText (Form1, Caption$)
      bNeedSave = TRUE
    END IF
    EXIT FUNCTION

    CASE WM_DESTROY
    PostQuitMessage(0)
    EXIT FUNCTION

    CASE WM_LBUTTONDOWN
    notice ("Made it!")
    EXIT FUNCTION

  END SELECT
END FUNCTION


SUB PosMainWindow (hWnd AS HWND)
  GetWindowRect (hWnd, &wRect)
  ww = GetSystemMetrics (SM_CXSCREEN)
  wh = GetSystemMetrics (SM_CYSCREEN)-GetSystemMetrics(SM_CYCAPTION)-5
  SetWindowPos (hWnd, NULL,0,0,ww,wh,SWP_SHOWWINDOW)
End Sub


Function AskAboutSave (hWnd AS HWND, szFileTitle$)
  Local afile$
  afile$ = szFileTitle$ & " has changed. Save it?"
  iReturn = MsgBox (afile$, "Confirm", 35)
  Function = iReturn
End Function


Sub notice(a$)
  MsgBox a$, "Notice", 64
End Sub
